/*
  lily-proto.hh -- declare class names.

  source file of the GNU LilyPond music typesetter

  (c)  1997--1998 Han-Wen Nienhuys <hanwen@stack.nl>
*/

#ifndef LILY_PROTO_HH
#define LILY_PROTO_HH
#include "proto.hh"


struct Absolute_dynamic_req;
struct Abbreviation;
struct Abbreviation_req;
struct Abbreviation_beam_req;
struct Abbreviation_beam_engraver;
struct Axis_group_element;
struct Axis_group;
struct Translator_group;
struct Translator;
struct Abbreviation_beam; 
struct Audio_element;
struct Audio_column;
struct Audio_item;
struct Audio_key;
struct Audio_meter;
struct Audio_note;
struct Audio_note_off;
struct Performance;
struct Audio_staff;
struct Audio_tempo;
struct Atom;
struct Bar;
struct Bar_column_engraver;
struct Bar_column;
struct Bar_engraver;
struct Bar_req;
struct Barcheck_req;
struct Beam;
struct Beam_engraver;
struct Beam_req;
struct Blank_req;
struct Bow;
struct Box;
struct Break_align_item;
struct Bracket_req;
struct Cadenza_req;
struct Change_iterator;
struct Change_translator;
struct Chord;
struct Clef_change_req;
struct Clef_item;
struct Clef_engraver;
struct Clef_performer;
struct Col_hpositions;
struct Chord;
struct Colinfo;
struct Collision;
struct Collision_engraver;
struct Command_req;
struct Command_script_req;
struct Complex_music;
struct Cresc_req;
struct Crescendo ;
struct Decresc_req;
struct Dots;
struct Dot_column;
struct Directional_spanner;
struct Disallow_break_req;
struct Durational_req;
struct Dynamic;
struct Dynamic_req;
struct Element_group;
struct Element_group_item;
struct Break_force_req;
struct General_script_def;
struct Graphical_element;
struct Music_output;
struct Music_output_def;
struct Global_translator;
struct Group_change_req;
struct Head_column;
struct Header;
struct Horizontal_align_item;
struct Horizontal_group_element;
struct Horizontal_group_item;
struct Horizontal_vertical_group;
struct Idealspacing;
struct Identifier;
struct Input_file;
struct Item;
struct Key;
struct Key_change_req;
struct Key_item;
struct Key_engraver;
struct Key_performer;
struct Keyword;
struct Keyword_table;
struct Lily_stream;
struct Line_of_score;
struct Line_of_staff;
struct Line_spacer;
struct Linestaff;
struct Local_key;
struct Local_key_item;
struct Local_key_engraver;
struct Lookup;
struct Lyric_item;
struct Lyric_req;
struct My_lily_lexer;
struct Measure_grouping_req;
struct Melodic_req;
struct Meter;
struct Meter_change_req;
struct Meter_engraver;
struct Meter_performer;
struct Midi_def;
struct Midi_duration;
struct Midi_header;
struct Midi_item;
struct Midi_key;
struct Midi_meter;
struct Midi_note;
struct Midi_note_event;
struct Midi_note_off;
struct Midi_output;
struct Midi_score;
struct Midi_stream;
struct Midi_tempo;
struct Midi_track;
struct Midi_walker;
struct Mixed_qp;
struct Molecule;
struct Multi_measure_rest;
struct Multi_measure_rest_req;
struct Multi_measure_rest_engraver;
struct Music_general_chord;
struct Musical_script_req;
struct Music_voice;
struct Musical_req;
struct Music;
struct Music_list;
struct My_lily_parser;
struct Note_column;
struct Note_column_engraver;
struct Note_performer;
struct Note_req;
struct Note_head;
struct Note_head_engraver;
struct Notename_table;
struct Offset;
struct Outputter;
struct Performer;
struct Paper_column;
struct Paper_score;
struct Paper_def;
struct Partial_measure_req;
struct Plet;
struct Plet_engraver;
struct Plet_req;
struct Plet_spanner;
struct Pulk_voice;
struct Pulk_voices;
struct Rational;
struct Engraver_group_engraver;
struct Performer;
struct Performer_group_performer;
struct Property_iterator;
struct Request;
struct Request_column;
struct Engraver;
struct Rest;
struct Rest_collision;
struct Rest_collision_engraver;
struct Rest_req;
struct Rhythmic_grouping;
struct Rhythmic_head;
struct Rhythmic_grouping_req;
struct Rhythmic_req;
struct Single_malt_grouping_item;
struct Separating_group_spanner;
struct Score;
struct Score_column;
struct Score_elem;
struct Score_elem_info;
struct Score_performer;
struct Script;
struct Script_column;
struct Script_def;
struct Script_engraver;
struct Script_req;
struct Simple_music;
struct Skip_req;
struct Slur;
struct Slur_engraver;
struct Slur_req;
struct Spacing_req ;
struct Span_dynamic_req;
struct Span_req;
struct Spanner;
struct Spring_spacer;
struct Staff_performer;
struct Staff_side;
struct Staff_symbol;
struct Stem;
struct Stem_beam_engraver;
struct Stem_req;
struct String;
struct Subtle_req;
struct Atom;
struct Symtable;
struct Symtables;
struct Super_elem;
struct Terminate_voice_req;
struct Translation_property;
struct Tempo_req;
struct Tex_stream;
struct Text_def;
struct Text_gob;
struct Text_item ;
struct Text_engraver;
struct Text_req;
struct Text_spanner;
struct Tie;
struct Tie_engraver;
struct Tie_req;
struct Time_description;
struct Timing_req;
struct Vertical_brace;
struct Vertical_spanner;
struct Vertical_group_element;
struct Vertical_group_spanner;
struct Vertical_align_spanner;
struct Vertical_align_engraver;
struct Vertical_align_element;
struct Voice;
struct Request_chord;
struct Voice_group_engravers;
struct Voice_group_performer;
struct Voice_list;
struct Voice_engravers;
struct Voicegroup;
struct Walker_engravers;
typedef Rational Moment;
#endif // LILY_PROTO_HH
